Go to the latest version of this document.

# ``twisted`.`protocols`.`amp`.`AmpList``

class documentation

`class AmpList(Argument): (source)`

Constructor: `AmpList(subargs, optional)`

View In Hierarchy

Convert a list of dictionaries into a list of AMP boxes on the wire.

For example, if you want to pass:

        [{'a': 7, 'b': u'hello'}, {'a': 9, 'b': u'goodbye'}]

You might use an AmpList like this in your arguments or response list:

        AmpList([('a', Integer()),
                 ('b', Unicode())])

Method | `__init__` | Create an AmpList.
Method | `fromStringProto` | Convert a string to a Python value.
Method | `toStringProto` | Convert a Python object to a string.
Instance Variable | `subargs` | Undocumented

Inherited from `Argument`:

Method | `fromBox` | Populate an 'out' dictionary with mapping names to Python values decoded from an 'in' AmpBox mapping strings to string values.
Method | `fromString` | Convert a string to a Python object. Subclasses must implement this.
Method | `retrieve` | Retrieve the given key from the given dictionary, removing it if found.
Method | `toBox` | Populate an 'out' AmpBox with strings encoded from an 'in' dictionary mapping names to Python values.
Method | `toString` | Convert a Python object into a string for passing over the network.
Instance Variable | `optional` | Undocumented

def __init__(self, subargs, optional=False): (source)
overrides `twisted.protocols.amp.Argument.__init__`

Create an AmpList.

Parameters
subargs:A `list` of (`bytes`, `Argument`) tuples. | a list of 2-tuples of ('name', argument) describing the schema of the dictionaries in the sequence of amp boxes.
optional | a boolean indicating whether this argument can be omitted in the protocol.

def fromStringProto(self, inString, proto): (source)
overrides `twisted.protocols.amp.Argument.fromStringProto`

Convert a string to a Python value.

Parameters
inString:`bytes` | the string to convert.
proto:AMP | the protocol we are converting for.

Returns
a Python object.

def toStringProto(self, inObject, proto): (source)
overrides `twisted.protocols.amp.Argument.toStringProto`

Convert a Python object to a string.

Parameters
inObject | the object to convert.
proto:AMP | the protocol we are converting for.

subargs = (source)

Undocumented